       IDENTIFICATION DIVISION.
       PROGRAM-ID. TXTCALC.
       ENVIRONMENT DIVISION.
       INPUT-OUTPUT SECTION.
       FILE-CONTROL.
      *
           SELECT CALC-EXP-FILE
                  ASSIGN TO DYNAMIC EXP-FILENAME
                  ORGANIZATION IS LINE SEQUENTIAL
                  ACCESS IS SEQUENTIAL
                  FILE STATUS IS EXP-FSTS.
      *
      ******************************************************************
      *
       DATA DIVISION.
      *
       FILE SECTION.
      *
      ******************************************************************
      *
       FD  CALC-EXP-FILE
           RECORD CONTAINS 80 CHARACTERS
           DATA RECORD IS CALC-REC.
       01  CALC-REC                 PIC X(80).
      *
      ******************************************************************
      *
       WORKING-STORAGE SECTION.
      *                       File indicators for the dynamic assign
       77  EXP-FILENAME             PIC X(80).
       77  EXP-FSTS                 PIC XX.
       77  CONTINUE-KEY             PIC X.
      *
       01  SWITCHES.
           05 OPEN-SW               PIC 9 VALUE ZERO.
           05 FOUND-SW              PIC 9 VALUE ZERO.
      *
       01  ERROR-RETCODE-VALUES.
      *           Type error
           02 TYPE-ERROR            PIC 99 VALUE 80.
      *           Open error
           02 OPEN-ERROR            PIC 99 VALUE 81.
      *          Key error on direct access file
           02 KEY-ERROR             PIC 99 VALUE 82.
      *
       01  CALC-EXPORT-VALUES.
      *
           05  CURRENT-VALUE            PIC 99     VALUE ZEROES.
           05  CURRENT-TAG              PIC X(20)  VALUE SPACES.
           05  CURRENT-ATTR             PIC X(40)  VALUE SPACES.
           05  XML-LINE             PIC X(72) VALUE
              '<?xml version="1.0" encoding="UTF-8" ?>'.
           05  DOC-LINE             PIC X(72) VALUE
              '<!--DOCTYPE RENTITY SYSTEM "rentity.xsd"-->'.
           05  YYMMDD.
               10  YY                   PIC 99.
               10  MM                   PIC 99.
               10  DD                   PIC 99.
           05  DATUM.
               10  TAG                  PIC 99.
               10  FILLER               PIC X   VALUE '.'.
               10  MON                  PIC 99.
               10  FILLER               PIC X   VALUE '.'.
               10  JAHR                 PIC 99.
      *
       01  METRIK-EXPORT-TAGS.
           05  FILE-TAGS.
               10  METRIC-TAG       PIC X(20) VALUE 'RENTITY_FILE'.
               10  PRODUCT-ATTR     PIC X(20) VALUE 'Product'.
SN0711         10  VERSION-ATTR     PIC X(20) VALUE 'Version'.
               10  SYSTEM-ATTR      PIC X(20) VALUE 'System '.
               10  SENDER-ATTR      PIC X(20) VALUE 'Source '.
               10  DATE-ATTR        PIC X(20) VALUE 'Date   '.
           05  ENTITY-TAGS.
               10  ENTITY-TAG       PIC X(20) VALUE 'REQU_ENTITY'.
               10  ENTITY-ATTR      PIC X(20) VALUE 'Entity'.
               10  NAME-ATTR        PIC X(20) VALUE 'EName'.
               10  TYPE-ATTR        PIC X(20) VALUE 'EType'.
           05  STRUCTURE-TAGS.
               10  ACTOR-TAG     PIC X(20) VALUE 'Actor_Attributes'.
               10  USECASE-TAG   PIC X(20) VALUE 'UseCase_Attributes'.
               10  OBJECT-TAG    PIC X(20) VALUE 'Object_Attributes'.
               10  INTERFAC-TAG  PIC X(20) VALUE 'Interface_Attributes'.
               10  TESTCASE-TAG  PIC X(20) VALUE 'TestCase_Attributes'.
               10  CHANGE-TAG       PIC X(20) VALUE 'Change_Rate'.
           05  ACTOR-TAGS.
               10  ROLE-TAG         PIC X(20) VALUE 'Nr_Roles'.
               10  VIEW-TAG         PIC X(20) VALUE 'Nr_Views'.
           05  USECASE-TAGS.
               10  PATH-TAG         PIC X(20) VALUE 'Nr_Paths'.
               10  STEP-TAG         PIC X(20) VALUE 'Nr_Steps'.
               10  INPUT-TAG        PIC X(20) VALUE 'Nr_Inputs'.
               10  OUTPUT-TAG       PIC X(20) VALUE 'Nr_Outputs'.
           05  OBJECT-TAGS.
               10  RELATION-TAG     PIC X(20) VALUE 'Nr_Relations'.
               10  METHOD-TAG       PIC X(20) VALUE 'Nr_Methods'.
               10  KEY-TAG          PIC X(20) VALUE 'Nr_Keys'.
               10  ATTR-TAG         PIC X(20) VALUE 'Nr_Attributes'.
           05  INTERFACE-TAGS.
               10  SOURCE-TAG       PIC X(20) VALUE 'Nr_Sources'.
               10  OPERATION-TAG    PIC X(20) VALUE 'Nr_Operations'.
               10  ARGUMENT-TAG     PIC X(20) VALUE 'Nr_Arguments'.
               10  RESULT-TAG       PIC X(20) VALUE 'Nr_Results'.
           05  TESTCASE-TAGS.
               10  TC-STEP-TAG      PIC X(20) VALUE 'Nr_Steps'.
TEMP           10  TC-OBJT-TAG      PIC X(20) VALUE 'Nr_Objects'.
               10  TC-ARGUMENT-TAG  PIC X(20) VALUE 'Nr_Arguments'.
               10  TC-RESULT-TAG    PIC X(20) VALUE 'Nr_Results'.
      *
      ******************************************************************
      *
       LINKAGE SECTION.
      *
      ******************************************************************
      *
       77  VERSION-NAME             PIC X(8).
      *
           COPY CALCPARM.
      *
           COPY CALCSUMS.
      *
      ******************************************************************
      *
       PROCEDURE DIVISION USING REPO-NAME,
                                VERSION-NAME,
                                EXTERNAL-REF,
                                OUTPUT-DIR,
                                SOFTCALC-COUNTS,
                                RETCODE.
      *
      ******************************************************************
      *
       CALC-OPENING SECTION.
      *
       OPEN-CALCREF-FILE.
      *
      *    DISPLAY 'REPO-NAME     = ' REPO-NAME
      *    DISPLAY 'REF-BASE-TYPE = ' REF-BASE-TYPE
      *    DISPLAY 'REF-BASE-NAME = ' REF-BASE-NAME
      *    DISPLAY 'REF-TARGET-TYPE = ' REF-TARGET-TYPE
      *    DISPLAY 'REF-TARGET-NAME = ' REF-TARGET-NAME
      *    ACCEPT CONTINUE-KEY
           MOVE ZERO TO RETCODE.
           IF REF-BASE-TYPE = 'OPEN'
              IF OPEN-SW = 1
                 CLOSE CALC-EXP-FILE
                 MOVE ZERO TO OPEN-SW
              END-IF
      ******************************************************************
      *    Open and init Calc Export File                              *
              MOVE SPACES TO EXP-FILENAME
              STRING OUTPUT-DIR      DELIMITED BY SPACE
                     '\'             DELIMITED BY SIZE
                     REPO-NAME       DELIMITED BY SPACE
                     '.xml'          DELIMITED BY SIZE
                 INTO EXP-FILENAME
              END-STRING
              MOVE ZEROS TO EXP-FSTS
              OPEN OUTPUT CALC-EXP-FILE
              IF EXP-FSTS  = ZEROES
TEST             DISPLAY '| Calc Import File was opened:' EXP-FILENAME
TEST***          ACCEPT CONTINUE-KEY
                 PERFORM WRITE-CALC-FILE-HEADER
              ELSE
                 MOVE OPEN-ERROR TO RETCODE
TEST             DISPLAY '| Open Error = ' EXP-FSTS
TEST             DISPLAY '| Calc Import File:' EXP-FILENAME
TEST             DISPLAY '| Press Enter to Continue !!'
TEST             ACCEPT CONTINUE-KEY
              END-IF
              GOBACK
           END-IF.
      *
       CLOSE-CALC-FILE.
      *
           IF REF-BASE-TYPE = 'CLOS'
              MOVE 'RENTITY' TO CURRENT-TAG
              PERFORM WRITE-FIRST-LEVEL-END
              CLOSE CALC-EXP-FILE
TEST          DISPLAY '| Calc Import File was closed:' EXP-FILENAME
TEST***       ACCEPT CONTINUE-KEY
              MOVE ZERO TO RETCODE
              GOBACK
           END-IF.
      *
      ******************************************************************
      *
       CALC-PROCESSING SECTION.
      *
       CHECK-REF-TYPE.
      *
           EVALUATE REF-BASE-TYPE
           WHEN 'PROD'
           WHEN 'SYST'
           WHEN 'DOCU'
           WHEN 'SECT'
           WHEN 'CASE'
           WHEN 'REQU'
              CONTINUE
           WHEN OTHER
              MOVE TYPE-ERROR TO RETCODE
TEST          DISPLAY 'Type Error = ' REF-BASE-TYPE
TEST          DISPLAY 'Press Enter to Continue !!'
TEST          ACCEPT CONTINUE-KEY
              GOBACK
           END-EVALUATE.
      *
       CHECK-REL-TYPE.
      *
           EVALUATE REF-TARGET-TYPE
           WHEN 'LIB '
           WHEN 'SYST'
           WHEN 'DOCU'
           WHEN 'SECT'
           WHEN 'CASE'
           WHEN 'REQU'
           WHEN 'DATA'
           WHEN 'OBJT'
           WHEN 'REPO'
           WHEN 'MASK'
           WHEN 'INPT'
           WHEN 'OUTP'
           WHEN 'RULE'
           WHEN 'ACT '
           WHEN 'TRIG'
           WHEN 'STEP'
           WHEN 'TEST'
              CONTINUE
           WHEN OTHER
              MOVE TYPE-ERROR TO RETCODE
TEST          DISPLAY 'Type Error = ' REF-TARGET-TYPE
TEST          DISPLAY 'Press Enter to Continue !!'
TEST          ACCEPT CONTINUE-KEY
              GOBACK
           END-EVALUATE.
      *
       INSERT-CALC-REFERENCE.
      *
           EVALUATE REF-TARGET-TYPE
              WHEN 'CASE'  PERFORM WRITE-CALC-USECASE
SN1008        WHEN 'ACT '  PERFORM WRITE-CALC-ACTOR
SN1107        WHEN 'OBJT'  PERFORM WRITE-CALC-OBJECT
              WHEN 'MASK'  PERFORM WRITE-CALC-INTERFACE
              WHEN 'REPO'  PERFORM WRITE-CALC-INTERFACE
              WHEN 'INPT'  PERFORM WRITE-CALC-INTERFACE
              WHEN 'OUTP'  PERFORM WRITE-CALC-INTERFACE
              WHEN 'TEST'  PERFORM WRITE-CALC-TESTCASE
              WHEN OTHER   CONTINUE
           END-EVALUATE.
           MOVE ZERO TO RETCODE.
TEST  *    DISPLAY 'RepoRef-Rec  written'
TEST  *    DISPLAY 'RepoRef-Type ' REF-TARGET-TYPE
TEST  *    DISPLAY 'RepoRef-Name ' REF-TARGET-NAME
TEST  *    ACCEPT CONTINUE-KEY.
       RETURN-TO-TEXTANAL.
           GOBACK.
      *
      ******************************************************************
      *
       CALC-PROCESSING SECTION.
      ************************
      *
       WRITE-CALC-FILE-HEADER.
      *  Create Metric Header
      *
           MOVE XML-LINE TO CALC-REC
           WRITE CALC-REC
           MOVE DOC-LINE TO CALC-REC
           WRITE CALC-REC
           MOVE 'RENTITY' TO CURRENT-TAG.
           PERFORM WRITE-FIRST-LEVEL-START.
           MOVE METRIC-TAG TO CURRENT-TAG.
           PERFORM WRITE-SECOND-LEVEL-START.
           MOVE PRODUCT-ATTR TO CURRENT-TAG
           MOVE REF-BASE-NAME TO CURRENT-ATTR
           PERFORM WRITE-THIRD-LEVEL-ATTR.
SN0711     MOVE VERSION-ATTR TO CURRENT-TAG
           MOVE VERSION-NAME TO CURRENT-ATTR
           PERFORM WRITE-THIRD-LEVEL-ATTR.
           MOVE SYSTEM-ATTR TO CURRENT-TAG
           MOVE REF-TARGET-NAME TO CURRENT-ATTR
           PERFORM WRITE-THIRD-LEVEL-ATTR.
           ACCEPT YYMMDD FROM DATE
           MOVE YY TO JAHR
           MOVE MM TO MON
           MOVE DD TO TAG
           MOVE DATE-ATTR TO CURRENT-TAG
           MOVE DATUM TO CURRENT-ATTR
           PERFORM WRITE-THIRD-LEVEL-ATTR.
           MOVE SENDER-ATTR TO CURRENT-TAG
           MOVE 'SofAudit' TO CURRENT-ATTR
           PERFORM WRITE-THIRD-LEVEL-ATTR.
           MOVE METRIC-TAG TO CURRENT-TAG.
           PERFORM WRITE-FILE-HEADER-END.
      *
      ******************************************************************
       WRITE-CALC-ACTOR.
      *                               write actor attributes
           MOVE ENTITY-TAG TO CURRENT-TAG
           PERFORM WRITE-SECOND-LEVEL-START.
           MOVE ENTITY-ATTR TO CURRENT-TAG
           MOVE 'ACTOR  ' TO CURRENT-ATTR
           PERFORM WRITE-SECOND-LEVEL-ATTR.
           MOVE NAME-ATTR   TO CURRENT-TAG
           MOVE REF-TARGET-NAME TO CURRENT-ATTR
           PERFORM WRITE-SECOND-LEVEL-ATTR.
           MOVE TYPE-ATTR   TO CURRENT-TAG
           MOVE 'REAL' TO CURRENT-ATTR
           PERFORM WRITE-SECOND-LEVEL-ATTR-LAST.
           MOVE ACTOR-TAG TO CURRENT-TAG
           PERFORM WRITE-THIRD-LEVEL-START.
           MOVE ROLE-TAG TO CURRENT-TAG
           MOVE 01 TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA
           MOVE VIEW-TAG TO CURRENT-TAG
           MOVE 02 TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA
           MOVE CHANGE-TAG TO CURRENT-TAG
070330     MOVE 1 TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA
           MOVE ACTOR-TAG TO CURRENT-TAG
           PERFORM WRITE-THIRD-LEVEL-END
           MOVE ENTITY-TAG TO CURRENT-TAG
           PERFORM WRITE-SECOND-LEVEL-END.
           EXIT.
      *
      ******************************************************************
       WRITE-CALC-USECASE.
      *                               write usecase attributes
           MOVE ENTITY-TAG TO CURRENT-TAG
           PERFORM WRITE-SECOND-LEVEL-START.
           MOVE ENTITY-ATTR TO CURRENT-TAG
           MOVE 'USECASE' TO CURRENT-ATTR
           PERFORM WRITE-SECOND-LEVEL-ATTR.
           MOVE NAME-ATTR   TO CURRENT-TAG
           MOVE REF-TARGET-NAME TO CURRENT-ATTR
           PERFORM WRITE-SECOND-LEVEL-ATTR.
           MOVE TYPE-ATTR   TO CURRENT-TAG
           MOVE 'ONLI' TO CURRENT-ATTR
           PERFORM WRITE-SECOND-LEVEL-ATTR-LAST.
           MOVE USECASE-TAG TO CURRENT-TAG
           PERFORM WRITE-THIRD-LEVEL-START.
           MOVE PATH-TAG TO CURRENT-TAG
           IF UC-PATH-NR > ZERO
              MOVE UC-PATH-NR TO CURRENT-VALUE
           ELSE
              MOVE 1 TO CURRENT-VALUE
           END-IF.
           PERFORM WRITE-FIFTH-LEVEL-DATA
           MOVE STEP-TAG TO CURRENT-TAG
           IF UC-STEP-NR > ZERO
              MOVE UC-STEP-NR TO CURRENT-VALUE
           ELSE
              MOVE 4 TO CURRENT-VALUE
           END-IF.
           PERFORM WRITE-FIFTH-LEVEL-DATA
           MOVE INPUT-TAG TO CURRENT-TAG
           IF UC-INPUT-NR > ZERO
              MOVE UC-INPUT-NR TO CURRENT-VALUE
           ELSE
              MOVE 2 TO CURRENT-VALUE
           END-IF.
           PERFORM WRITE-FIFTH-LEVEL-DATA
           MOVE OUTPUT-TAG TO CURRENT-TAG
           IF UC-OUTPUT-NR > ZERO
              MOVE UC-OUTPUT-NR TO CURRENT-VALUE
           ELSE
              MOVE 3 TO CURRENT-VALUE
           END-IF.
           PERFORM WRITE-FIFTH-LEVEL-DATA
           MOVE CHANGE-TAG TO CURRENT-TAG
070330     MOVE 1 TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA
           MOVE USECASE-TAG TO CURRENT-TAG
           PERFORM WRITE-THIRD-LEVEL-END
           MOVE ENTITY-TAG TO CURRENT-TAG
           PERFORM WRITE-SECOND-LEVEL-END.
           EXIT.
      *
      ******************************************************************
       WRITE-CALC-OBJECT.
      *                               write object attributes
           MOVE ENTITY-TAG TO CURRENT-TAG
           PERFORM WRITE-SECOND-LEVEL-START.
           MOVE ENTITY-ATTR TO CURRENT-TAG
           MOVE 'OBJECT ' TO CURRENT-ATTR
           PERFORM WRITE-SECOND-LEVEL-ATTR.
           MOVE NAME-ATTR   TO CURRENT-TAG
           MOVE REF-TARGET-NAME TO CURRENT-ATTR
           PERFORM WRITE-SECOND-LEVEL-ATTR.
           MOVE TYPE-ATTR   TO CURRENT-TAG
           MOVE REF-TARGET-TYPE TO CURRENT-ATTR
           PERFORM WRITE-SECOND-LEVEL-ATTR-LAST.
           MOVE OBJECT-TAG TO CURRENT-TAG
           PERFORM WRITE-THIRD-LEVEL-START.
           MOVE RELATION-TAG TO CURRENT-TAG
           IF OBJ-REL-NR > ZERO
              MOVE OBJ-REL-NR TO CURRENT-VALUE
           ELSE
              MOVE 2 TO CURRENT-VALUE
           END-IF
           PERFORM WRITE-FIFTH-LEVEL-DATA
           MOVE METHOD-TAG TO CURRENT-TAG
           IF OBJ-METH-NR > ZERO
              MOVE OBJ-METH-NR TO CURRENT-VALUE
           ELSE
              MOVE 8 TO CURRENT-VALUE
           END-IF
           PERFORM WRITE-FIFTH-LEVEL-DATA
           MOVE KEY-TAG TO CURRENT-TAG
           IF OBJ-KEY-NR > ZERO
              MOVE OBJ-KEY-NR TO CURRENT-VALUE
           ELSE
              MOVE 2 TO CURRENT-VALUE
           END-IF
           PERFORM WRITE-FIFTH-LEVEL-DATA
           MOVE ATTR-TAG TO CURRENT-TAG
           IF OBJ-ATTR-NR > ZERO
              MOVE OBJ-ATTR-NR TO CURRENT-VALUE
           ELSE
              MOVE 20 TO CURRENT-VALUE
           END-IF
           PERFORM WRITE-FIFTH-LEVEL-DATA
           MOVE CHANGE-TAG TO CURRENT-TAG
070330     MOVE 1 TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA
           MOVE OBJECT-TAG TO CURRENT-TAG
           PERFORM WRITE-THIRD-LEVEL-END
           MOVE ENTITY-TAG TO CURRENT-TAG
           PERFORM WRITE-SECOND-LEVEL-END.
           EXIT.
      *
      ******************************************************************
       WRITE-CALC-INTERFACE.
      *                               write interface attributes
           MOVE ENTITY-TAG TO CURRENT-TAG
           PERFORM WRITE-SECOND-LEVEL-START.
           MOVE ENTITY-ATTR TO CURRENT-TAG
           MOVE 'INTERFACE' TO CURRENT-ATTR
           PERFORM WRITE-SECOND-LEVEL-ATTR.
           MOVE NAME-ATTR   TO CURRENT-TAG
           MOVE REF-TARGET-NAME TO CURRENT-ATTR
           PERFORM WRITE-SECOND-LEVEL-ATTR.
           MOVE TYPE-ATTR   TO CURRENT-TAG
           MOVE REF-TARGET-TYPE TO CURRENT-ATTR
070330     IF REF-TARGET-TYPE = 'INPT' OR 'OUTP'
070330        MOVE 'FILE' TO CURRENT-ATTR
070330     ELSE
070330     END-IF
071111     IF REF-TARGET-TYPE = 'REPO'
071111        MOVE 'LIST' TO CURRENT-ATTR
071111     END-IF
           PERFORM WRITE-SECOND-LEVEL-ATTR-LAST.
           MOVE INTERFAC-TAG TO CURRENT-TAG
           PERFORM WRITE-THIRD-LEVEL-START.
           MOVE SOURCE-TAG TO CURRENT-TAG
           IF INF-SRC-NR > ZERO
              MOVE INF-SRC-NR TO CURRENT-VALUE
           ELSE
              MOVE 1 TO CURRENT-VALUE
           END-IF
           PERFORM WRITE-FIFTH-LEVEL-DATA
           MOVE OPERATION-TAG TO CURRENT-TAG
           IF INF-OPER-NR > ZERO
              MOVE INF-OPER-NR TO CURRENT-VALUE
           ELSE
              MOVE 4 TO CURRENT-VALUE
           END-IF
           PERFORM WRITE-FIFTH-LEVEL-DATA
           MOVE ARGUMENT-TAG TO CURRENT-TAG
           IF INF-ARG-NR > ZERO
              MOVE INF-ARG-NR TO CURRENT-VALUE
           ELSE
              MOVE 8 TO CURRENT-VALUE
           END-IF
           PERFORM WRITE-FIFTH-LEVEL-DATA
           MOVE RESULT-TAG TO CURRENT-TAG
           IF INF-RESU-NR > ZERO
              MOVE INF-RESU-NR TO CURRENT-VALUE
           ELSE
              MOVE 8 TO CURRENT-VALUE
           END-IF
           PERFORM WRITE-FIFTH-LEVEL-DATA
           MOVE CHANGE-TAG TO CURRENT-TAG
070330     MOVE 1 TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA
           MOVE INTERFAC-TAG TO CURRENT-TAG
           PERFORM WRITE-THIRD-LEVEL-END
           MOVE ENTITY-TAG TO CURRENT-TAG
           PERFORM WRITE-SECOND-LEVEL-END.
           EXIT.
      *
      ******************************************************************
       WRITE-CALC-TESTCASE.
      *                               write interface attributes
           MOVE ENTITY-TAG TO CURRENT-TAG
           PERFORM WRITE-SECOND-LEVEL-START.
           MOVE ENTITY-ATTR TO CURRENT-TAG
           MOVE 'TESTCASE' TO CURRENT-ATTR
           PERFORM WRITE-SECOND-LEVEL-ATTR.
           MOVE NAME-ATTR   TO CURRENT-TAG
           MOVE REF-TARGET-NAME TO CURRENT-ATTR
           PERFORM WRITE-SECOND-LEVEL-ATTR.
           MOVE TYPE-ATTR   TO CURRENT-TAG
           MOVE 'REQU' TO CURRENT-ATTR
           PERFORM WRITE-SECOND-LEVEL-ATTR-LAST.
           MOVE TESTCASE-TAG TO CURRENT-TAG
           PERFORM WRITE-THIRD-LEVEL-START.
           MOVE TC-ARGUMENT-TAG TO CURRENT-TAG
           MOVE 04 TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA
           MOVE TC-RESULT-TAG TO CURRENT-TAG
           MOVE 02 TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA
           MOVE TC-OBJT-TAG TO CURRENT-TAG
           MOVE 03 TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA
           MOVE TC-STEP-TAG TO CURRENT-TAG
           MOVE 03 TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA
           MOVE CHANGE-TAG TO CURRENT-TAG
070330     MOVE 1 TO CURRENT-VALUE
           PERFORM WRITE-FIFTH-LEVEL-DATA
           MOVE TESTCASE-TAG TO CURRENT-TAG
           PERFORM WRITE-THIRD-LEVEL-END
           MOVE ENTITY-TAG TO CURRENT-TAG
           PERFORM WRITE-SECOND-LEVEL-END.
           EXIT.
      *
      ****************************************************************
       WRITE-XML SECTION.
      ************************************************ 1st Level
       WRITE-FIRST-LEVEL-START.
           MOVE SPACES TO CALC-REC
           STRING ' <'              DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  '>'               DELIMITED BY SIZE
              INTO CALC-REC
           WRITE CALC-REC.
      ************************************************ 1st Level
       WRITE-FIRST-LEVEL-END.
           MOVE SPACES TO CALC-REC.
           STRING ' </'             DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  '>'               DELIMITED BY SIZE
              INTO CALC-REC.
           WRITE CALC-REC.
      ************************************************ 2nd Level
       WRITE-SECOND-LEVEL-START.
           MOVE SPACES TO CALC-REC.
           STRING '   <'            DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
              INTO CALC-REC.
           WRITE CALC-REC.
      ************************************************ 2nd Level
       WRITE-SECOND-LEVEL-ATTR.
           MOVE SPACES TO CALC-REC.
           STRING '    '            DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  ' = "'            DELIMITED BY SIZE
                   CURRENT-ATTR     DELIMITED BY SPACE
                  '"'               DELIMITED BY SIZE
              INTO CALC-REC.
           WRITE CALC-REC.
      ************************************************ 2nd Level
       WRITE-SECOND-LEVEL-ATTR-LAST.
           MOVE SPACES TO CALC-REC.
           STRING '    '            DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  ' = "'            DELIMITED BY SIZE
                   CURRENT-ATTR     DELIMITED BY SPACE
                  '" >'             DELIMITED BY SIZE
              INTO CALC-REC.
           WRITE CALC-REC.
      ************************************************ 2nd Level
       WRITE-SECOND-LEVEL-END.
           MOVE SPACES TO CALC-REC.
           STRING '   </'           DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  '>'               DELIMITED BY SIZE
              INTO CALC-REC.
           WRITE CALC-REC.
      ************************************************ 2nd Level
       WRITE-FILE-HEADER-END.
           MOVE SPACES TO CALC-REC.
           MOVE   '   />'  TO CALC-REC.
           WRITE CALC-REC.
      ************************************************ 3rd Level
       WRITE-THIRD-LEVEL-START.
           MOVE SPACES TO CALC-REC.
           STRING '     <'          DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  '>'               DELIMITED BY SIZE
              INTO CALC-REC.
           WRITE CALC-REC.
      ************************************************ 3rd Level
       WRITE-THIRD-LEVEL-ATTR.
           MOVE SPACES TO CALC-REC.
           STRING '    '            DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  ' = "'            DELIMITED BY SIZE
                   CURRENT-ATTR     DELIMITED BY SPACE
                  '"'               DELIMITED BY SIZE
              INTO CALC-REC.
           WRITE CALC-REC.
      ************************************************ 3rd Level
       WRITE-THIRD-LEVEL-LAST-ATTR.
           MOVE SPACES TO CALC-REC.
           STRING '    '            DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  ' = "'            DELIMITED BY SIZE
                   CURRENT-ATTR     DELIMITED BY SPACE
                  '" >'             DELIMITED BY SIZE
              INTO CALC-REC.
           WRITE CALC-REC.
      ************************************************ 3rd Level
       WRITE-THIRD-LEVEL-END.
           MOVE SPACES TO CALC-REC.
           STRING '     </'         DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  '>'               DELIMITED BY SIZE
              INTO CALC-REC.
           WRITE CALC-REC.
      ************************************************ 5th Level
       WRITE-FIFTH-LEVEL-DATA.
           MOVE SPACES TO CALC-REC.
           STRING '         <'      DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  '>'               DELIMITED BY SIZE
                   CURRENT-VALUE    DELIMITED BY SIZE
                  '</'              DELIMITED BY SIZE
                   CURRENT-TAG      DELIMITED BY SPACE
                  '>'               DELIMITED BY SIZE
              INTO CALC-REC.
           WRITE CALC-REC.
           EXIT.
      *
      ******************************************************************
      *                      end of CALCXML
      ******************************************************************
